# AGENT-BASED ARTIFICIAL INTELLIGENCE - HANDS-ON LESSONS CODES (A.Y. 2023/2024)

This is the official repository of the course 
_Agent-Based Artificial Intelligence_ held by Prof.
Tommaso Di Noia, Politecnico di Bari. It hosts the implementation codes 
written during the hands-on lessons of the course held by Vincenzo 
Paparella, Ph.D. student at Politecnico di Bari.

## Contents
The contents of this repository are organized in the following way.
You may find algorithms written in Python and exercises written in
Prolog.

The algorithms written in Python are accompanied by some Google Colab Notebook
as study supporting material.

In addition, the solution of some exercises is provided.

**PYTHON IMPLEMENTATION**
- `search`: this folder contains algorithms 
to solve problems with **tree/graph search** and **local search**;
- `csp`: this folder contains algorithms to solve **constraint
satisfaction problems**;
- `game`: this folder contains algorithms to solve **zero-sum games**.
 

**PROLOG IMPLEMENTATION**
- `prolog`: this folder contains solved exercises in **prolog**. Please, note 
that the file `ContainersCSP.pl` refers to the resolution of the exercise 
_CSP_Containers_challenge_19-20.pdf_ in Prolog.

**ADDITIONAL MATERIAL**
- `exercises`: this folder contains exercises about the topics above.
- `colab`: this folder contains Google Colab Notebooks containing the supporting material
for the hands-on lessons.
This material should not be intended as a substitution of the materials and books
suggested for the theoretical study.

## Contacts
If you need any information about this course, you may contact Prof. Tommaso Di Noia
(tommaso.dinoia@poliba.it) or Vincenzo Paparella (vincenzo.paparella@poliba.it).

This repository is currently maintained by Vincenzo Paparella. If you have questions about the codes within this repository,
you may contact him by e-mail (or Teams if you are a student).
## List of Contributors
- Tommaso Di Noia
- Alberto Carlo Maria Mancino
- Vincenzo Paparella
